/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 

/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     source code: ES5 (ECMAScript 5, JavaScript 5)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */

//  xxxxxxxxxxxxxxx           version: 2.1           xxxxxxxxxxxxxxxx     

//  xxxxxxxxxxxxxxx    global variable declarations  xxxxxxxxxxxxxxxx

// var parameters are bellow (12)  - Synchronize this section with wm5.html form parameter values 
var parad = '1';      // if (parad === '1') => line task; if (parad==='2') => divide task; if (parad==='3') => imaginary circle task  
var rnd = false;  //  random (true) or pseudorandom (false) generator
var jumping = false;   // if  jumping = true => the points will not appear on the imaginary line from one to the other (from left to right or vice versa), but the points will be shown by a random event
var item_cnt = 6;   // total item count
var p_cnt = 5;   // total point (circle) count
var offset = 3;   // point offset (task difficulty)
var before = 6;      // number of basic time cycles BEFORE first circles exposition (x clock).   Better to choose EVEN number (2,4,6,..)
var time = 5;      // (stimulus exposition time) in ms (x clock)   
var after = 5;       // delay between stimulus and response (number of basic time cycles) =>  (x clock)  
var monochrome= true;   // if true monochrome (black) color circle.  false = circles  will be in random Colors
var demo = true;   // demo mode = true => show correct solution
    // var store = false;  => only local scope in theEnd()


var clock = 100;  // basic timer resolution in ms
var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().
var step = -1;   // global timer counter 
var item = 0;   // current item      
var cor = [];   // correct answer (dot/circle with offset) within each item
var ans = [];  //  user answers for each item (dependent var) 
var xy = [];    //  jagged array [item][] Within each [item] is separate array with grid coordinates [0.index= x; 1.index =y]
var p_cur = 0;   // current point see: drawPoint()
var r = 10;        // dot/circle radius (px) 
var edge = r;     // canvas border 
var hor= [];      // direction => horizontal line (true) or vertical line (false)
var flp = [];     // demo mode => xy-coordinates of first and last point for each item   => 1dim = item; 2dim= first or last point;  3dim= x or y coord (0 = x, 1=y) 
var idle = 0;     // global timer counter (escape drawing point)
var dirty = false;  // if  (dirty==true) => user changed any options in form
var cc= 10;         //  number of imaginary circles
var is_storage= false; // local storage is enabled on user browser or not
var startTime;    // start time for task



// create/start Timer, [center panels], and show start panel.. 
function init() {    
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {my_timer()},clock); // Returns an intervalID. intervalID is a unique interval ID you can pass to clearInterval()  
  
	is_storage= isStorage() && storageAvailable('localStorage');
  if (is_storage)  {
    document.getElementById('store_group').style.display= 'block';
		document.getElementById('no_storage').style.display= 'none';
  }	
	
  if (!supportedTransform())  {
    doCenter(document.getElementById('start'));
    doCenter(document.getElementById('response'));
  }  
	
	setIns();
	
  showStart();
	
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  
{
  if (typeof(Storage) !== 'undefined') {
     return true;                 
  } 
  else {
    return false;    
  }  
}


// necessarily because of IE11 offline mode
function storageAvailable(type) 
{
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


function supportedTransform() {
  var prefixes = 'transform WebkitTransform MozTransform OTransform msTransform'.split(' ');
  var div = document.getElementById('start');
  for(var i = 0; i < prefixes.length; i++) {
    if(div && div.style[prefixes[i]] !== undefined) {
      return prefixes[i];
    }
  }
  return false;
}


function doCenter(e)  {
  if (e.id === 'start')  {        
    e.style= (window.innerWidth > 600 && window.innerHeight > 600 ) 
    ? 'position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;'  
    : 'position:absolute;min-width:75%;min-height:75%;margin:auto;overflow:auto;';  
  }
  else if (e.id === 'response')  {
    e.style='position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;';    
  } 
}


// show main start panel 
function showStart()  {        
  document.getElementById('end').style.display= 'none';
	document.getElementById('google_wrapper').style.display= 'none';
	document.getElementById('store_id').style.display= 'none';
	document.getElementById('table_grp').style.display= 'none';
		
	document.getElementById('start').style.display= 'block';	
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user defined research Options
function hideOption()  {
  setVarPar();   
  document.getElementById('options').style.display= 'none'; 
  document.getElementById('start').classList.add('child');   
  document.getElementById('show_option').style.display= 'block';   
  document.getElementById('start_div').style.display= 'block';     
  document.getElementById('hide_option').style.display= 'none';   
  document.getElementById('instructions').style.display= 'block';
	//document.getElementById('start_div').style= 'text-align:center';  // bug?  (firefox auto remove class 'center' when set style.display.none;)
  //document.getElementById('show_option').style= 'text-align:center';   // bug?  
  refMsg(); 
	setIns();  
}


// refresh main validator message for user defined OPTIONS 
function refMsg()   
{ 	
	if ( optionsValid() )  {
    document.getElementById('is_valid').textContent=  dirty == true ? 'All your settings have been successfully updated' : '';  
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#000000'); 
  }
  else  {
    document.getElementById('is_valid').textContent='Some of your options are incorrectly set. They were not updated.';   // These settings are marked in red. 
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#ff0000;font-weight:bold'); 
  } 	
}


// check for validity.valid object in all input type='number'
function optionsValid()  {    		
  var res= document.getElementById('item_cnt').validity.valid  && document.getElementById('p_cnt').validity.valid 
     && document.getElementById('offset').validity.valid &&  document.getElementById('before').validity.valid 
     && document.getElementById('time').validity.valid && document.getElementById('after').validity.valid ;
  return res; 		
}


/* refresh paradigm Option (update *_msg label) => give user short option HELP
   count variable properties count: 11  */
function refOpt(e)  {
  dirty=true;      
  var my_id = e.id, msg = document.getElementById(my_id + '_msg'), s = 'Values within this range are allowed: ', s2= ' with step= ';
  
	switch (my_id)
	{
	
	  case 'paradigm':  
    if (e.value == '1')  {
      msg.textContent= 'User must specify one point that is NOT within the same imagined line (0 = for none)';          
      document.getElementById('jumping_msg').textContent= (document.getElementById('jumping').value === '0') ? 'The dots will appear to each other (one to the other)' : 'The dots will appear in an random sequence';
      document.getElementById('jumping').disabled= false; // document.getElementById('jumping').removeAttribute('disabled');
    }
    else if (e.value == '2')   {
      msg.textContent= 'User must specify one of the points NOT in the same distance from the others (0 = for none)';
      document.getElementById('jumping_msg').textContent= 'Not available for the selected paradigm'; 
      document.getElementById('jumping').disabled= true; //   document.getElementById('jumping').setAttribute('disabled', 'true');      
    }    
    else   {
      msg.textContent= 'The user must find a point that is not in the same imagined circle (0 = for none)';
      document.getElementById('jumping_msg').textContent= (document.getElementById('jumping').value === '0') ? 'The dots will appear to each other (one to the other)' : 'The dots will appear in an random sequence';
      document.getElementById('jumping').disabled= false;  //   document.getElementById('jumping').setAttribute('disabled', 'true');      
    }      
    break;
		
		case 'random':  
			msg.textContent= e.value == '0' ? 'The solutions of all tasks will be selected randomly' : 'Solutions will be selected so that their number is balanced (approximately equal)';
			break;
			
		case 'jumping':  
			msg.textContent= e.value == '0' ? 'The dots will appear to each other (one to the other)' : 'The dots will appear in an random sequence';
			break;
			
		case 'item_cnt':          
			if (e.validity.valid)  {
				msg.textContent= 'Total number of items= ' + e.value;
				msg.removeAttribute('class');  
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');    // msg.className = 'error';
			}
			break;
		 
    case 'p_cnt':
			if (e.validity.valid)  {
				 msg.textContent= 'Number of dots in each task: ' + e.value; 
				 msg.removeAttribute('class'); 
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');    // msg.className = 'error';
			}
			break;
		
    case 'offset':  
			if (e.validity.valid)  {
				msg.textContent= 'A larger number means a more complicated task (1..5). Offset: ' + e.value;
				msg.removeAttribute('class');
			 }
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step; 
				msg.setAttribute('class', 'error');
			}
			break;
		
    case 'before': 
		case 'time':
			if (e.validity.valid)  {
				msg.textContent=  e.value + ' ms'; 
				msg.removeAttribute('class');
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step; 
				msg.setAttribute('class', 'error');
			}          
			break; 
				
    case 'after':
			if ( e.validity.valid ) {
				msg.textContent= e.value + ' ms (also Time delay = Time of displaying the correct answer)';
				msg.removeAttribute('class');
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');
			}
			break;
		
		case 'monochrome':  
			msg.textContent= e.checked ? ' (Dots will only appear in black - monochrome)' : ' (Dots will be displayed in full color or only black-red in demo mode)';
			break;
		
		case 'demo':
			msg.textContent= e.checked ? ' (Yes - demo mode)' : ' (No)';    
			break;
	
		case 'store':                                                                                                                                            
			msg.textContent= (e.value === '1') ? 'This web application will store the results inside your web browser (no expiration date). Useful for group research' : 'This web application will not store results within your web browser. Data is lost when the browser tab is closed';
			break;
	
	}  // switch (my_id)
	
  refMsg();   
}


// set instructions text depending on user selected paradigm type 
function setIns()  
{ 
	document.getElementById('instructions').style.display= 'block';	
	var p= parseInt(document.getElementById('paradigm').value,10);
	for (var i=1; i<=3; i++)  {
		if ( i == p ) {
		  document.getElementById('ins_parad' + i).style.display= 'block';
		  document.getElementById('ans_parad' + i).style.display= 'block';	
		}		 
		else {
		  document.getElementById('ins_parad' + i).style.display= 'none';
		  document.getElementById('ans_parad' + i).style.display= 'none';	
		}		 	 
	}
	document.getElementById('ins_demo').style.display= document.getElementById('demo').checked ? 'block' : 'none';
}


// start task (research)
function startTask()   
{    
  setPar();  
	
  if (r < 1)  {
    document.getElementById('is_valid').textContent='Too small screen resolution. In Options, you need to reduce the number of dots or change the paradigm';  
    document.getElementById('is_valid').style= 'color:red;font-weight:bold;text-align:center';
    return;
  }   

  initLayout();           
	
	rndSol();  // must be before setCoord() 
	
  if (parad === '3') { 
		setCoord3(); 
	}
  else {
		setCoord12();        
  }
 
  startTime = new Date();	
	idle= 0;        // reset global timer counter (escape drawing point)
  item= 0;
  step= 0;   // 'activate' Timer   
}


// init visible/invisible html dom elements. init canvas 
function initLayout()  
{
	var c= document.getElementById('canvas');      
	c.style.display= 'block';
	c.width= window.innerWidth;  
	c.style.width= canvas.width + 'px';	     
	c.height= window.innerHeight;   
	c.style.height= canvas.height + 'px';  // https://css-tricks.com/whats-the-difference-between-width-height-in-css-and-width-height-html-attributes/ 		
	 
	document.getElementById('start').style.display= 'none'; 
    //window.moveTo(0, 0);
	  //window.resizeTo(screen.width, screen.height);		
}


// set user variable parameters. don't use this code in setPar() => eq: document.getElementById('time').value are not updated to real value!!  
function setVarPar()  {   
  
	parad= document.getElementById('paradigm').value;    // if (parad === '1') => line task; if (parad==='2') => divide task; if (parad==='3') => imaginary circle task  
  
	rnd =  (document.getElementById('random').value === '0') ? true : false; //  random (true) or pseudorandom (false) generator
  
	jumping = (document.getElementById('jumping').value === '1') ? true : false;   // jumping or not jump  
  
	if (document.getElementById('item_cnt').validity.valid) {
		item_cnt= parseInt(document.getElementById('item_cnt').value); 
  }
	
	if (document.getElementById('p_cnt').validity.valid) {
		p_cnt= parseInt(document.getElementById('p_cnt').value);
  }
	
	if (document.getElementById('offset').validity.valid) {
		offset= parseInt(document.getElementById('offset').value);   
  }
	
	if (document.getElementById('before').validity.valid) {
		before= Math.round(parseInt(document.getElementById('before').value, 10)/clock);
  }
	
	if (document.getElementById('time').validity.valid) {
		time= Math.round(parseInt(document.getElementById('time').value, 10)/clock);  
  }
	
	if (document.getElementById('after').validity.valid) {
		after= Math.round(parseInt(document.getElementById('after').value, 10)/clock); 
  }
	
	monochrome= (document.getElementById('monochrome').checked) ? true: false;  // if true monochrome (only black) color circle.  false = circles  will be in random Colors
  
	demo= (document.getElementById('demo').checked) ? true: false; // demo mode = true => show correct solution
	
  if (parad === '2') { 
		jumping= false;
  }		
	
}


// application set research (paradigm) parameters => this is not available to user
function setPar()  { 
  //edge= Math.round(0.05 * Math.min(window.innerWidth,window.innerHeight));    //  5% min (width, height)   
  r = Math.floor(Math.min(window.innerWidth,window.innerHeight))/(p_cnt+3);  // divide screen into equal parts:  p_cnt + 1*up/left edge + 1*down/right edge     
  if (parad === '1')  {
    r= r/2;        // circle d= 2*r
  }
  else if (parad ==='2')  {
    r= r/(10);       // circle d= 2*r   => must have space when divide line into 5 equal parts (5*2=10)
  }
  else  {
    r = Math.floor(Math.floor(Math.min(window.innerWidth/2,window.innerHeight/2)-Math.min(window.innerWidth/8,window.innerHeight/8))/(cc+1));   // inner edge = r; outer edge = r    
  }
  edge= r;          
  cor = [];   // correct number of visible shapes within each item
  ans = [];   //  user answers for each item (dependent var)
  xy = [];    //  jagged array [item][] Within each [item] is separate array with grid coordinates [0.index= x; 1.index =y]  
  hor= [];    // direction => horizontal line (true) or vertical line (false)  
}

 
// stimulus generator for (parad === '1') => line task; if (parad==='2') => divide task
// generate window.p_cnt circles for each window.item_cnt => xy[item_cnt][0..p_cnt-1] with or without window.offset
function setCoord12()  
{   
  var x1, x2, y1, y2;  // first point (x1,y1) => with index: 0; last point (x2,y2) with index: p_cnt-1       
  var dx, dy, lrt, tmp; // x, y coord for all other point (1..p_cnt-2), left-to-right or right-to-left line direction, tmp 
  var canvas = document.getElementById('canvas');                     
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    xy[i]= [];          
    if (Math.random() < 0.5)      
    { // horizontal line  
      hor[i]= true;
      y1= getRndInt(edge, canvas.height-edge);   // first point (x1,y1) => random y-coord (index: 0)    
      x1= edge;  /*(parad==='1') ? edge : getRndInt(edge, off * edge);*/    // first point (x1,y1) => x-coord (index: 0)                                       
      x2= canvas.width-edge; /*(parad ==='1') ? canvas.width-edge : getRndInt(canvas.width-edge-off*edge, canvas.width-edge);*/    // last point (x2,y2) => x-coord  (index: p_cnt-1)  
      do {
        y2= getRndInt(edge, canvas.height-edge);     // last point (x2,y2) => y-coord  (index: p_cnt-1)   
      }
      while (Math.abs(y1 - y2) < canvas.height/5); // must have minimum angle      
    }
    else  
    { // vertical line
      hor[i]= false;       
      x1= getRndInt(edge, canvas.width-edge);   // first point (x1,y1) => random x-coord (index: 0)             
      y1= edge; /*(parad === '1') ? edge: getRndInt(edge, off * edge) ;*/   // first point (x1,y1) => y-coord (index: 0)
      y2= canvas.height-edge;  /*(parad === '1') ? canvas.height-edge: getRndInt(canvas.height-edge-off*edge, canvas.height-edge);*/   // last point (x2,y2) => y-coord  (index: p_cnt-1)        
      do {
        x2= getRndInt(edge, canvas.width-edge);   // last point (x2,y2) => x-coord  (index: p_cnt-1)   
      }
      while (Math.abs(x1 - x2) < canvas.width/5); // must have minimum angle               
    }     
    xy[i].push([x1, y1]);    // first one (index: 0)
    var tmp= p_cnt-2;    // divide line into p_cnt-2 equal segments
    for (var j=1; j<=tmp; j++)  {
      dx= div_x(x1, x2, -j/(tmp-j+1));    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1 
      dy= div_y(y1, y2, -j/(tmp-j+1));    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1               
      xy[i].push([dx, dy]);        
    } 
    xy[i].push([x2, y2]);  // last point with index: (p_cnt-1)  
  }   // i = for item_cnt 
  
  for (var i=0; i<item_cnt; i++)  
  {      
    lrt =  (Math.random() < 0.5 ) ? true : false;   // left-to-right or right-to-left line direction
    if (lrt)  xy[i].reverse();        // reverse random 50%
  }  
  memo_flp();   
  if (jumping)   {
    for (var i=0; i<item_cnt; i++)  { 
      xy[i]= shuffle(xy[i]);   
    }                     
  }
  // add random offset for each target (correct solution) point based on window.offset 
  if (parad === '1')  {
    var my_off= (3 + 3 - window.offset);  // local offset => don't change window.offset
  }
  else  {
    var my_off= -(6-offset)/offset;       // my_off= -(6-j)/j;
  }   
  for (var i=0; i<item_cnt; i++)  
  {    // i= item     
    for (var j=0; j<=p_cnt-1; j++)  
    {             // for each point in each item (task)        
      if  (j === cor[i]-1)     
      {  // change coord - add random offset for correct answer =>  if this point is correct  answer                  
        if (parad === '1')  
        {           
          if (hor [i] == true) {
           xy[i][j][1]+=  y_offset(xy[i][j][1], my_off);    // add random y-offset => [1]= y         
          }
          else  {
            xy[i][j][0]+= x_offset(xy[i][j][0],  my_off);   // add random x-offset =>  [0]= x                   
          }
        }
        else  
        {           
          var x1=xy[i][j][0];   // this point x-coord
          var y1=xy[i][j][1];   // this point y-coord
          if ( j < p_cnt-1 )  {   // every point except last
            var x2=xy[i][j+1][0];  // next point x-coord
            var y2=xy[i][j+1][1];    // next point y-coord
            //my_off= -(6-offset)/offset;       // my_off= -(6-j)/j;
          }
          else  {           // only each last point
            var x2=xy[i][j-1][0];  // prior point x-coord
            var y2=xy[i][j-1][1];    // prior point y-coord 
            //my_off= -offset/(6-offset);     //my_off= -j/(6-j);
          }                    
          xy[i][j][0]= div_x(x1, x2, my_off);    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1 
          xy[i][j][1]= div_y(y1, y2, my_off);    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1               
        }   
      }    //  if  ( j == cor[i]-1)  => if this point is correct              
    }    // for (var j=0; j<=p_cnt-1; j++)     => each point    
  }    //   for (var i=0; i<item_cnt; i++)  => each item
  
}


// stimulus generator for (parad === '3') => imaginated  circle
// generate window.p_cnt circles for each window.item_cnt => xy[item_cnt][0..p_cnt-1] with or without window.offset
function setCoord3()   {
    
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    xy[i]= [];          
    hor[i]= (Math.random() < 0.5) ? true: false;   // horizontal line    
    var rnd= getRndInt(1,cc);   // random circle count 1..10  => (1..number of imaginary circles)      
    var angle= getRndInt(0,2*Math.PI);  
    for (var ind=0; ind < p_cnt; ind++)  {
      var x = canvas.width/2  + (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) * Math.cos(angle);    // polar radius = (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) 
      var y = canvas.height/2 + (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) * Math.sin(angle);     // polar coordinate y
      xy[i].push([x, y]);    // save polar coordinates (x,y)     
      angle+= 2*Math.PI/p_cnt;          
    }  
  }   
  for (var i=0; i<item_cnt; i++)  {      
    if  (Math.random() < 0.5 ) xy[i].reverse();   // counterclockwise or clockwise  => reverse random 50%
  }       
  if (jumping)   {
    for (var i=0; i<item_cnt; i++)  { 
      xy[i]= shuffle(xy[i]);   
    }                     
  } 
  
  // this must be after shuffle() [reverse()] function calls => add random offset for each target (correct solution) point based on window.offset   
  var my_off= (3 + 3 - window.offset);  // point offset
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    for (var j=0; j<=p_cnt-1; j++)  
    {             // for each point in each item (task)        
      if  ( j === cor[i]-1)    
      {         // correct answer (target dot) => add random offset for each target (correct solution) point based on window.offset       
        if (Math.random() < 0.5) {     
          xy[i][j][1]+=  y_offset(xy[i][j][1], my_off);    // 50% add random y-offset => [1]= y            
        }
        else  {      
          xy[i][j][0]+= x_offset(xy[i][j][0],  my_off);   // 50% add random x-offset =>  [0]= x                      
        }    
      }       
    } 
  } 
    
}


// x1 => first point P1 x-coord
// x2 => second point P2 y-coord
// n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: x-coord of Q point
function div_x(x1,x2,n)  {   
  return (x1-n*x2)/(1-n);
}


// y1 => first point P1 y-coord
// y2 => second point P2 y-coord
// n  => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: y-coord of Q point
function div_y(y1,y2,n)  {   
  return (y1-n*y2)/(1-n);
}


// unbiased shuffle algorithm: Fisher-Yates (aka Knuth) Shuffle.
function shuffle(arr) {
  var cur_index = arr.length, tmp, rnd_index;
  // While there remain elements to shuffle...
  while (0 !== cur_index) {    
    rnd_index = Math.floor(Math.random() * cur_index);     // Pick a remaining element...
    cur_index = cur_index - 1;   
    tmp = arr[cur_index];          // And swap it with the current element.
    arr[cur_index] = arr[rnd_index];
    arr[rnd_index] = tmp;
  }
  return arr;
}


// memorize each start point and end point  (remember they can be shuffled  if (window.jumping==true) ). see drawPoint()
function memo_flp()  {
  for (var i=0; i<item_cnt; i++)  {            
    flp[i]= [];          
    flp[i].push( [ xy[i][0][0], xy[i][0][1] ] );    // first point: x-coord for i-item, first point y-coord for i-item    
    flp[i].push( [ xy[i][p_cnt-1][0], xy[i][p_cnt-1][1] ] );    // last point: x-coord for i-item, last point y-coord for i-item
  } 
}


// set random or pseudorandom (equal frequencies for each categories) solutions
function rndSol()  { 
  if  (rnd)    {
  for (var i=0; i<item_cnt; i++)  {  
      cor[i]= Math.floor(Math.random()*(p_cnt+1));      // returns a random integer from 0 to p_cnt
  } 
  }
  else   
  {  
    var cat= p_cnt+1;      // number of categories
    var m= Math.floor(item_cnt/(cat));   // maximum permitted number (frequency)    
    if (m<1) m= 1;        
    var freq= [];   //  frequency array => previously selected frequencies. each must be < m
    for (var i=0; i<=p_cnt; i++)  {
      freq[i]= 0; 
    }          
    // pseudorandom generator = each category must have equal frequency 
    for (var i=0; i<cat*m && i<item_cnt; i++)  {    
      do
        var tmp= Math.floor(Math.random()*cat);      // returns a random integer from 0 to p_cnt  
      while  (freq[tmp]+1 > m);
      cor[i]= tmp;
      freq[tmp]++;
    }
    // for remainder items => each category only once <= (m+1)     
    for (var j=i; j<item_cnt; j++)  {    
      do
        var tmp= Math.floor(Math.random()*cat);      // returns a random integer from 0 to p_cnt  
      while (freq[tmp]+1 > m+1);
      cor[j]= tmp;
      freq[tmp]++;           
    }     
  }                             
}


function getRndInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


function drawCross()  {
  var canvas= document.getElementById('canvas');   
  var x= Math.round(canvas.width/2);
  var y= Math.round(canvas.height/2);
  var d = Math.floor(Math.min(x,y)/4);  // 1/8 min(width, height)  
  drawLine(x-d,y,x+d,y); // horizontal
  drawLine(x,y-d,x,y+d); // vertical 
}


function drawLine(x1,y1,x2,y2)  {
  var ctx= document.getElementById('canvas').getContext('2d'); 
  ctx.beginPath();
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);
  ctx.lineWidth= 1;
  ctx.strokeStyle='#000000';  // always black
  ctx.stroke();     
}


// p_cur => ordinal number of visible point (circle)
function drawPoint(p_cur)  {    
  //if (p_cur < 0 || p_cur > p_cnt-1) return;  
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas        
  var flag = ( p_cur == cor[item]-1 && demo) ? true : false;   // draw target point in red color (only in demo mode)                                   
  drawCircle(xy[item][p_cur][0], xy[item][p_cur][1], flag);
  //drawBorder();                 
}


// show correct solution in Demo mode
function drawDemo()  {
  //if (p_cur < 0 || p_cur > p_cnt-1) return;  
  var canvas= document.getElementById('canvas');
  var ctx = document.getElementById('canvas').getContext('2d'), flag, x, y, d=0; 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas        
  for (var j=0; j<=p_cnt-1; j++)  
  {   
    flag = (j === cor[item]-1) ? true : false;       // draw target point in red color  (always for this procedure)                            
    drawCircle(xy[item][j][0], xy[item][j][1], flag);    // don't change offset coord (they are already changed in drawPoint - must be changed only once)         
    ctx.font = r + 'px Arial';         // begin of draw point number within each Circle
    ctx.textAlign = 'center';
    ctx.fillStyle = ( flag ) ? '#000000' : '#ff0000';  // fill in black or red color
    ctx.fillText((j+1), xy[item][j][0], xy[item][j][1]);     // end of draw point number within each Circle
    if (!flag && parad === '3' && d ===0) {      // non-target stimulus for imagined circle paradigm
       d  = Math.sqrt( (xy[item][j][0] - canvas.width/2) * (xy[item][j][0] - canvas.width/2)  + (xy[item][j][1] - canvas.height/2)*  (xy[item][j][1] - canvas.height/2) );
    }                    
  }       
  if (parad === '3')  {
    ctx.beginPath();
    ctx.arc(canvas.width/2, canvas.height/2, d, 0, 2*Math.PI);     //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);                         
    ctx.lineWidth = 1;
    ctx.strokeStyle= '#000000';      
    ctx.stroke(); 
    //ctx.font= 0.1*document.getElementById('canvas').height + 'px Calibri';   // the height of the text in pixels is equal to the font size in pts when the font is defined with the font property of the canvas context
    ctx.fillStyle = 'lime'; // fuchsia     
    ctx.fillText('Correct: ' + cor[item], canvas.width/2, canvas.height/2);            
  }
  else  
  {
    drawLine(flp[item][0][0], flp[item][0][1], flp[item][1][0], flp[item][1][1]);
    if (hor[item])  {
      x= ( flp[item][0][0] <= canvas.width/2) ? 0.25*canvas.width : 0.75*canvas.width; // ltr = true/false
      y= ( flp[item][0][1] <= canvas.height/2) ? 0.75*canvas.height : 0.25*canvas.height;   
    }
    else  {
      x= ( flp[item][0][0] <= canvas.width/2) ? 0.75*canvas.width: 0.25*canvas.width; // ltr = true/false
      y= ( flp[item][0][1] <= canvas.height/2) ? 0.25*canvas.height : 0.75*canvas.height;   
    }        
    //ctx.font= 0.1*document.getElementById('canvas').height + 'px Calibri';   // the height of the text in pixels is equal to the font size in pts when the font is defined with the font property of the canvas context
    ctx.fillStyle = 'lime'; // fuchsia     
    ctx.fillText('Correct: ' + cor[item], x, y); 
  }
  //drawBorder();     
}


function drawCircle(x,y,is_red)  {
  var ctx = document.getElementById('canvas').getContext('2d');
  ctx.beginPath();
  ctx.arc(x,y,window.r,0,2*Math.PI);     //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);       
  if (!demo) { 
    (monochrome==true) ? ctx.fillStyle = 'black' : ctx.fillStyle= getRandomColor();       //ctx.fillStyle =  (xy[item][i][2] == 0) ?  'black' : 'red';    //  getRandomColor();          
  }
  else  {
    (is_red==true)  ? ctx.fillStyle = 'red' :  ctx.fillStyle = 'black';   
  }
 ctx.fill();
}


// par: x = dot x-coord;   dif = real number = dot offset => difficulty
// return x offset in range +/-[ dif * 0.05*window.innerWidth] 
function x_offset(x,dif)  {
  var off = (Math.random() < 0.5) ? 0.05*window.innerWidth*dif  : -0.05*window.innerWidth*dif;    // 50% chance => sign +/-           
  if (x + off < edge || x + off > window.innerWidth - edge) off=-1*off;  
  return off;
}


// par: y = dot y-coord;   dif = real number = dot offset => difficulty  
// return y offset in range +/-[ dif * 0.05*window.innerHeight] 
function y_offset(y,dif)  {
  var off = (Math.random() < 0.5) ? 0.05*window.innerHeight*dif  : -0.05*window.innerHeight*dif;    // 50% chance => sign +/-           
  if (y + off < edge || y + off > window.innerHeight - edge) off=-1*off;  
  return off; 
}


function getRandomColor() {
  var letters = '0123456789ABCDEF';
  var color = '#';
  for (var i = 0; i < 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// main application Timer handler
function my_timer()  
{        
  if (step<0) return;  // nop, idle
  step++;  
  var canvas= document.getElementById('canvas');  
  if (step < before-1)  
  {  // time before main stimulus (points) period
    p_cur = 0;             
    if (step % 2 !== 0)  {     // always trigger this in first timer call
     drawCross();     // Draw Cross only if it is odd number  (1,3,5,..)  example if (before==6) = 3xflick     
    }
    else   {       // for even numbers  (2,4,6,..) => clear previous cross
     canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);     // clear canvas => clear Cross in 2,4,6 step 
    }        
  }      
  else if (step === before-1)   
  {   // clear last cross if exists     
    canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);     // ALWAYS clear canvas before main stimulus display
    idle= time-1;   // draw 1. point in next timer call (after 100ms clock)  => because step =1 (escape first 100ms clock time)  
  }    
  else if (p_cur < p_cnt)  
  {   // start with main stimulus (points/circles) drawing   
    idle++;
    if (idle == time )   
    {        // escape until time period (time=each point presentation time) is trigger
      canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);     // clear previous point
      drawPoint(p_cur);         // draw crrent point
      p_cur++;   // this don't work in drawPoint() 
      idle=0;     // reset escape (idle) counter       
    }            
  }        
  else if (p_cur >= p_cnt)  
  {   // delay period   
     idle++;
     if (idle == time)  { canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height); }   // clear previous point
		 if (idle < after) { return; }   // escape until delay period is trigger
     if (demo && p_cur == p_cnt ) {       
       drawDemo();    
       p_cur++;     
       idle=0;               
     }
     else  {              // nop (only erase stimulus) in delay period       
       step = -1;         // Timer is Finally 'stop', nop, idle, do none, Timer no operation
       p_cur = 0;       
       showResponse();  
     }  
   }   
     
} 


function keyUp(event)  {          
  var e = event ||  window.event;    // event = use the value of event if available or   window.event = if not assume it's IE and use window.event   
  e.preventDefault();            
  if (e.keyCode === 13) {   
    nextItem();         
  }
}


function nextItem()  {
  var node= document.getElementById('answer');
  var tmp =  node.value;  
  if (!node.validity.valid) {    // (!node.validity.valid || !isInt(tmp) || tmp < 0 || tmp > 10)      
    document.getElementById('answer_val').textContent= 'You must enter an integer in the range: 0..10'; 
    document.getElementById('answer').focus(); 
    return;
  } 
  document.getElementById('answer_val').textContent=''; 
  tmp = Math.round(parseInt(tmp, 10));       
  ans[item]= tmp;     // store validated user answer 
  node.value= '';          // reset user answer (default answer for next item)
  node= document.getElementById('response');
  node.style.display='none';            
  if (item < xy.length - 1) {    // show next task       
    idle= 0;
    item++;
    document.getElementById('canvas').style.display='block';
    step=0;     // 'activate' Timer again 
  }
  else  {               
		theEnd();    
  }
}


// show response div (panel with user answer)
function showResponse()  {
  var node= document.getElementById('canvas');
  node.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);     // clear canvas 
  node.style.display='none'; 
  var node= document.getElementById('response');
  node.style.display='block'; 
  document.getElementById('answer').focus(); 
}


// return integer into string hh:mm:ss time format
// input par: total == integer (time in seconds)
function stringTime(total) 
{
  var hh = Math.floor(total/(60*60));         
  var div_min = total % (60 * 60);
  var mm = Math.floor(div_min / 60);       
  var div_sec = div_min % 60;
  var ss = Math.ceil(div_sec);    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = '0'+hh;}     
  if (mm < 10) {mm = '0'+mm;}
  if (ss < 10) {ss = '0'+ss;} 
  return hh + ':' + mm + ':' + ss;
} 


// end of task (research)
function theEnd()  {
  
	document.getElementById('response').style.display= 'none';
  document.getElementById('end').style.display= 'block';  
  document.getElementById('canvas').style.display= 'none';
	
	var endTime = new Date();   // see:  https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/getTime
  var task_time= ( endTime.getTime() - startTime.getTime() ) / 1000;  // seconds (convert time difference from milliseconds to seconds)
	task_time= stringTime(task_time);
		
	var res=0, max_p= cor.length;  
  for (var j=0; j!= max_p; j++)   {
    if (cor[j] == ans[j]) { 
		  res++;
		}
  }
    
  document.getElementById('score').textContent= 'Sum of points= ' + res + '. Maximum points= ' + max_p  + '. Percentage: ' + Math.round(100*res/max_p).toFixed(3) + '%'; 
 
  document.getElementById('l_ts').textContent='Last completed research: ' + new Date();
  document.getElementById('l_res').style.display= 'block';


  document.getElementById('google_wrapper').style.display= 'block';
  document.getElementById('no_google').textContent= '';
  try  {
    drawClientData(res);
  }
  catch (e)  {
		document.getElementById('google_wrapper').style.display= 'none';  // hide possible previous results
    document.getElementById('no_google').textContent= 'You must have an available internet connection to display graphs and tables. Make sure you are online.'; 
  }  

  try 
  {
    if (is_storage && document.getElementById('store').value === '1') {
			setStorage(max_p, res, task_time);  
    }
		else  {
			document.getElementById('table_grp').style.display= 'none';
			document.getElementById('store_id').style.display= 'none';
		}
  }        
  catch (e)  { 
    document.getElementById('table_grp').style.display= 'block';
		document.getElementById('table_grp').textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
	
}


// async google chart api..
// res => sum of points in task
function drawClientData(res) {    
  //    xxxxxxxxxxx     chart2 => BarChart   xxxxxxxxxxxxxxxxx  
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Item number');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Answer');      
  data.addColumn('number', 'Correct'); 
  data.addColumn('number', 'Item score');    
  for(var i = 0; i < ans.length; i++)  {  
    var tmp= (ans[i] === cor[i]) ? 1: 0;
    data.addRow( [  (i+1).toString() + '. item',  ans[i],  cor[i], tmp ] );        
  }                    
  options= {
   title: 'Total score = ' + res,
   width: '100%'   
  };    
  document.getElementById('chart2').style.display = 'block';   
  new google.visualization.ColumnChart(document.getElementById('chart2')).draw(data, options);     // Create and draw the visualization.    
  //    xxxxxxxxxxxxxx          Frequencies table        xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  var elem= document.getElementById('table');
  elem.title='Total score=' + res;
  elem.style.display = 'block'; 
  new google.visualization.Table(elem).draw(data, options);     
}


// v2.1 => begin of new code for export localStorage app data:  data= localStorage.getItem('myApp-v1.0');

// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   {
  document.getElementById('hide_option').style.display ='block';
  document.getElementById('options').style.display= 'block';
  document.getElementById('start').classList.remove('child');  // don't work in <= IE 9    
  document.getElementById('start_div').style.display='none';   
  document.getElementById('show_option').style.display ='none';  
  document.getElementById('hide_option').style='text-align:center';  // bug? auto-remove style when element.style.display='none'
  /* document.getElementById('ins_parad1').style.display ='none'; 
		document.getElementById('ins_parad2').style.display ='none'; 
		document.getElementById('ins_parad3').style.display ='none'; */
	document.getElementById('instructions').style.display= 'none'; 
	document.getElementById('store_oper').style.display= 'none';
	if (is_storage && localStorage.getItem('wm5-v2.1')) 
  {
    var cnt= JSON.parse(localStorage.getItem('wm5-v2.1')).length;                                                        
    document.getElementById('store_cnt').textContent=  'You have a total of ' + cnt  + ' results stored in your web browser.';
    if (cnt > 0) {
			document.getElementById('store_oper').style.display= 'table';   // xxx
		}
	}
  dirty= false;
  document.getElementById('is_valid').textContent='';  // tmp reset validator message
}


// Formats the date in the desired format. If you do not want this string format do not call this function. use: new Date()
function setDate()  
{
	var today = new Date();
	var dd = today.getDate();
	var mm = today.getMonth()+1; 
	var yyyy = today.getFullYear();
	if(dd<10) { dd='0'+dd; } 
	if(mm<10) {	mm='0'+mm; } 
	today = dd+'.' + mm + '.' +yyyy;
	return today;
}


/* Store the results of the last completed task in the user's browser
   set user data into window.localStorage. Parameters:	 
	 max_points = maximum possible score in task 
	 points = sum of points in task
	 total_time => task time in hh:mm:ss format   */ 	 
function setStorage(max_points, points, total_time)   
{  
	var oldItems = JSON.parse(localStorage.getItem('wm5-v2.1')) || []; 
  var id= oldItems.length + 1;     	
	// set new 'record'
  var newItem = {
      'id' : id,
      'date' : setDate(),   //new Date(), 					
			'max-points': max_points,
			'points' : points,			
			'paradigm' : parad,			
			'generator':    rnd == true ? 1 : 0,
      'dot-mode': jumping == true ? 1 : 0, 
			'items': item_cnt,
			'dot-count' : p_cnt, 
			'offset': offset, 
			'before' :  before * clock, 
			'display' : time * clock,
      'delay' : after * clock, 			
			'monochrome' : monochrome == true ? 1 : 0,
			'demo' : demo == true ? 1 : 0,			
			'total-time': total_time
  };

  oldItems.push(newItem);

  localStorage.setItem('wm5-v2.1', JSON.stringify(oldItems));
  
	document.getElementById('table_grp').style.display= 'block';
  document.getElementById('store_id').style.display= 'block';
  document.getElementById('store_id').textContent= 'The results are stored in your browser. ID= ' + id ;
  
	createTableJSON(document.getElementById('table_grp'), oldItems); 

}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement('table');
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement('th');      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= '';
  elem.appendChild(table);
}


// clear web browser storage data for this application
function clrStorage()  
{  
  var cnt= localStorage.getItem('wm5-v2.1') ? JSON.parse(localStorage.getItem('wm5-v2.1')).length : 0;                                                        
  if (cnt === 0)  {
    alert('You have no data to delete');
    return;
  }  
  if ( !window.confirm('You have a total of ' + cnt  + ' results stored in your web browser. Continue?') ) { 
   return;
 }                                             
 if (window.confirm('Delete total saved application data:  '  + cnt + '. This action cannot be undone. Final confirmation?') ) 
 {  
   window.localStorage.removeItem('wm5-v2.1'); 
   document.getElementById('store_cnt').textContent= 'All data has been deleted. No data.';
	 document.getElementById('store_oper').style.display= 'none';
 }  
}


// copy data from user web browser to the Clipboard 
function copyStorage()  
{  
  var data= localStorage.getItem('wm5-v2.1');
	if (!data)  {
    alert('You have no data to Copy');
    return;
  }  
	data = JSON.parse(data); 
	var arr= jsonToArray(data);	
	copy2DToClipboard(arr);
}	


// convert json object into 2D array
// data = JSON object
// return 2D array
function jsonToArray(data)  
{
   // extract column (fields) names  
  var total= data.length, col = [], row, res=[];  // res= result (2d array) 
  for (var i = 0; i < total; i++) {
    for (var key in data[i]) {
			if (col.indexOf(key) === -1)  {
				col.push(key);  // col= columns (fields) names
			}
    }
  } 
	res.push(col);  // add field names as 1 row
  var c = col.length;    // column count  
  // add JSON data to the 2d array as rows.
  for (var i = 0; i < total; i++) 
  {
		row= [];
    for (var j = 0; j < c; j++)  {     
      row.push(data[i][col[j]]);
    }
		res.push(row);
  }
	return res;	
}


// https://stackoverflow.com/questions/60698115/how-to-copy-a-javascript-2d-array-to-clipboard-to-paste-it-in-excel
// copy 2D array to Clipboard
function copy2DToClipboard(arr) {
  var csv = '', row, cell;
  for (row = 0; row < arr.length; row++) {
    for (cell = 0; cell < arr[row].length; cell++) {
      csv += (arr[row][cell]+'').replace(/[\n\t]+/g, ' ');
      if (cell+1 < arr[row].length) csv += '\t';
    }
    if (row+1 < arr.length) { 
			csv += '\n'; 
		}
  }
  copyTextToClipboard(csv);
}


// copy 2D array (or text) to Clipboard
function copyTextToClipboard(txt) 
{	
	if (!navigator.clipboard) {
    fallbackCopy(txt);
    return;
  }
  navigator.clipboard.writeText(txt).then(function() {
   //alert('Async: Copying to Clipboard was successful!');
  }, function(err) {
    alert('Oops, could not copy data. Error: ' + err);
  });
}


// copied from https://stackoverflow.com/questions/400212/how-do-i-copy-to-the-clipboard-in-javascript
// fallback copy text to clipboard
function fallbackCopy(txt) 
{
  var ta = document.createElement('textarea');
  ta.value = txt; 
  // Avoid scrolling to bottom
  ta.style.top = '0';
  ta.style.left = '0';
  ta.style.position = 'fixed';
  document.body.appendChild(ta);
  ta.focus();
  ta.select();
  try {
    var successful = document.execCommand('copy');
    var msg = successful ? 'successful' : 'unsuccessful';
  } catch (err) {
    alert('Oops, unable to copy. Error: ' + err);
  }
  document.body.removeChild(ta);
}


// https://stackoverflow.com/questions/2004555/how-can-i-make-javascript-make-produce-new-page
// displays user saved results (Window.localStorage application data) in new empty web page (tab) 
function newWin()
{ 
	var data = JSON.parse(localStorage.getItem('wm5-v2.1'))
	createTableJSON(document.getElementById('table_grp'), data);
	var stl= '<style>table{margin:1em auto;border:thick solid #000;border-collapse:collapse}td,th{border:medium solid #000;text-align:center;padding:.5em}th{font-weight:bold}</style>';
	var tbl= document.getElementById('table_grp').innerHTML;	
	var win = window.open('');
  win.document.write('<html><head><title>Saved cumulative data</title>' + stl + '</head><body>' + tbl + '</body></html>');
  win.focus();
}


// https://stackoverflow.com/questions/2004555/how-can-i-make-javascript-make-produce-new-page
// displays Latest research results in new empty web page (tab) 
// parameter: id => DOM/html object id (div or table)
function newWinLast()
{ 
	var e = document.getElementById('table');		
	var stl= '<style>table{margin:1em auto;border:thick solid #000;border-collapse:collapse}td,th{border:medium solid #000;text-align:center;padding:.5em}th{font-weight:bold}</style>';
	var tbl= e.innerHTML; 	
	var win = window.open('');
	win.document.write('<html><head><title>Latest research data</title>' + stl + '</head><body>' + tbl + '</body></html>');
	win.focus();
}


// copy only latest task results (data) to the Clipboard 
function copyLast()  
{     
  var tbl= document.getElementById('table').getElementsByTagName('table')[0];  // note: id='table' is html div element		
	if (tbl)  {
		var data= table2DArray(tbl);
		if (data.length > 0) {
			copy2DToClipboard(data);
		}
	}
}	


// https://stackoverflow.com/questions/3065342/how-do-i-iterate-through-table-rows-and-cells-in-javascript
// input argument tbl == html/DOM  table  object
// return 2D array
function table2DArray(tbl) 
{
	var res = [];	 
	for (var i = 0, row; row = tbl.rows[i]; i++) 
	{   //iterate through rows. rows would be accessed using the 'row' variable assigned in the for loop
	  res[i]= [];		
		for (var j = 0, col; col = row.cells[j]; j++) {  //iterate through columns. columns would be accessed using the 'col' variable assigned in the for loop			 
		  res[i][j]= col.textContent;
		}  
	}
	return res;				
}
